from rocolib.api.components.Component import Component
from rocolib.api.Function import Function


self = Component()

self.addSubcomponent("beam", "SimpleRectBeam")
self.addSubcomponent("brain", "Brains", inherit="brain", prefix=None)

self.addParameter("length", 90, paramType="length")
self.addParameter("width", 50, paramType="length")
self.addParameter("depth", 20, paramType="length")
self.addParameter("offset", (0,0))

self.addConstraint(("beam", "width"), "depth")
self.addConstraint(("beam", "depth"), "width")
self.addConstraint(("beam", "length"), "length")

self.addConstraint(("beam", "width#minValue"), "brain", 'x.get("height")')
self.addConstraint(("beam", "depth#minValue"), "brain", 'x.get("width")')
self.addConstraint(("beam", "length#minValue"), "brain", 'x.get("length")')

self.addConnection(("beam", "face1"),
                   ("brain", "decoration"),
                   mode="hole", offset=Function(params=("offset")))

self.inheritAllInterfaces("beam", prefix=None)

self.toLibrary("MountedBrains")
