from rocolib.api.components.Component import Component

c = Component()

# BOX

c.addParameter("seats", 6, valueType="int", minValue=2, maxValue=10)
c.addParameter("spacing", 25, paramType="length")

for i in range(3):
    c.addSubcomponent("boat%d"%i,"BoatBase", inherit=True, prefix=None, root=True)

    c.addSubcomponent("portsplit%d"%i,"SplitEdge")
    c.addSubcomponent("starsplit%d"%i,"SplitEdge")

    c.addConstraint(("portsplit%d"%i,"botlength"), ("boat.length", "seats"), "[x[0]]")
    c.addConstraint(("portsplit%d"%i,"toplength"), ("boat.length", "seats"), "[x[0]/(1.*x[1])] * x[1]")
    c.addConstraint(("starsplit%d"%i,"toplength"), ("boat.length", "seats"), "[x[0]]")
    c.addConstraint(("starsplit%d"%i,"botlength"), ("boat.length", "seats"), "[x[0]/(1.*x[1])] * x[1]")

    c.addConnection(("portsplit%d"%i, "botedge0"), ("boat%d"%i, "portedge"), angle=-90)
    c.addConnection(("starsplit%d"%i, "topedge0"), ("boat%d"%i, "staredge"), angle=-90)

for i in range(10):
    nm = "seat%d"%i
    c.addSubcomponent(nm, "Rectangle")
    c.addConstraint((nm, "l"), ("spacing", "seats"), "(%d < x[1]) and x[0] or 0" % i)
    c.addConstraint((nm, "w"), ("boat.length", "seats"), "x[0]/(1.*x[1])")
    if (i % 2):
        c.addConnection(("starsplit0", "botedge%d" % i), (nm, "l"))
        c.addConnection(("portsplit1", "topedge%d" % i), (nm, "r"))
    else:
        c.addConnection(("starsplit1", "botedge%d" % i), (nm, "l"))
        c.addConnection(("portsplit2", "topedge%d" % i), (nm, "r"))

c.toLibrary("Trimaran")
