from rocolib.api.components import DecorationComponent
from rocolib.api.composables.graph.Face import Rectangle

class Cutout(DecorationComponent):
    def define(self):
        self.addParameter("dx", 10, paramType="length")
        self.addParameter("dy", 20, paramType="length")
        self.addParameter("d", overrides={
            "dx": 'c.getParameter("d")',
            "dy": 'c.getParameter("d")',
        })

    def assemble(self):
        dx = self.getParameter("dx")
        dy = self.getParameter("dy")
        self.addFace(Rectangle("r0", dx, dy), prefix="r0")

if __name__ == "__main__":
    Cutout.test()
